<?php
//网站入口类 
class app {

	//预加载文件
	public function init(){
		require_once 'config.php';
		require_once 'lib/router.php';
		require_once 'lib/super.php';
		require_once 'lib/smarty/smarty.class.php';
	}
	
	//加载crtl文件
	public function requireCtrl($module){
		if(!file_exists('ctrl/'.$module.'/'.$module.'Ctrl.class.php')){
			self::error('404');
		}
		require_once 'ctrl/'.$module.'/'.$module.'Ctrl.class.php';
		$ctrlClass  = $module.'Ctrl';
		$tpl = self::requireSmarty($module);
		return new $ctrlClass($tpl);
	}
	
	//加载模板
	public function requireSmarty($dir){
		$smarty = new Smarty();
		$smarty->template_dir=Template_dir.$dir.'/';
		$smarty->compile_dir=Compile_dir;
		$smarty->cache_dir=Cache_dir;
		$smarty->left_delimiter=Left_delimiter;
		$smarty->right_delimiter=Right_delimiter;
		$smarty->cache_lifetime=Cache_lifetime;
		$smarty->caching=Caching;
		return $smarty;
	}
	
	//显示错误
	public function error($type=''){
		header('Content-Type:text/html;charset=utf-8');
		echo '出错啦<br/>';	
		switch($type){
			case 'model':
				echo 'model 文件不存在';break;
			case 'ctrl':
				echo 'ctrl 文件不存在';break;
			case 'method':
				echo 'method 不存在';break;
			case '404':
				include '404.html';break;
			default:
				echo '<pre>';
				print_r($type);
				echo '</pre>';
				break;
		}
		//出错后停止运行
		exit;
	}
	
	//程序运行入口
	public function run(){
		//加载公共文件
		self::init();
		
		//url路由解析
		$router = new Router();
		$module = $router->getCtrl();
		$action = $router->getAction();
		$_GET = $router->getParams();
		$_REQUEST = array_merge($_POST,$_GET);
		
		// echo $module."  ".$action."<br/>";
		// print_r($_GET);

		//实例化ctrl
		$ctrl = self::requireCtrl($module);
		
		try { 
			if(method_exists($ctrl,$action)){
				//响应url的操作 
				$ctrl->$action();
			}else{
				self::error('method');
			}
		} catch (Exception $e) { 
			self::error($e);
		}
	}
}
?>