<?php 
//网站基类
//super web 
class Web {
	private static $con = null;
	
	//数据库连接
	public function conDb($module){
		if (self::$con==null){
			require_once 'lib/dataBase.php';
			self::$con = new dataBase(HOST,USER,PWD,DB);
		}
		return self::requireModel($module);
	}
	
	//加载model文件
	public function requireModel($module){
		if(!file_exists('model/'.$module.'/'.$module.'Model.class.php')){
			exit('没有model文件');
		}
		require_once 'model/'.$module.'/'.$module.'Model.class.php';
		$modelClass = $module.'Model';
		return new $modelClass(self::$con); 
	}
}

//super Model
class Model extends Web {
    public $con;
	
    public function Model(&$con) {
        $this->con = &$con;
    }
	public function setDebug($flag=false){
		$this->con->debug=$flag;		
	}
}

//super Ctrl
class Ctrl extends Web {
	public $viewObj;

    public function Ctrl(&$view ){
		$this->viewObj = &$view;
    }
	
	public function getIndexUrl(){
		return 'http://'.$_SERVER['SERVER_NAME'].':'.$_SERVER["SERVER_PORT"].WEBDIR;
	}
}

//测试输出专用函数
function p($arr){
	echo "<pre>";
	print_r($arr);
	echo "</pre>";
}
?>